# git tag is 1.9.12, but release name is 2.0-RC2
# https://github.com/falkTX/Carla/releases/tag/v1.9.12
%define	tag	v1.9.12

# current revision of source/native-plugins/external git submodule
%define plugins_rev  98723d7

%define	beta	rc2
%define	rel	3
Summary:	Audio plugin host
Name:		Carla
Version:	2.0
Release:	0.%{beta}.%{rel}
License:	GPL v2+
Group:		Applications
Source0:	https://github.com/falkTX/Carla/archive/%{tag}/%{name}-%{tag}.tar.gz
# Source0-md5:	11b75d313629dbf20f71e9e36ba8a0c0
Source1:	https://github.com/falkTX/Carla-Plugins/archive/%{plugins_rev}/Carla-Plugins-%{plugins_rev}.tar.gz
# Source1-md5:	b8bb65277e724d022b7ed54ead4bc286
Patch0:		pypkgdir.patch
Patch1:		soundfonts_path.patch
URL:		http://kxstudio.linuxaudio.org/Applications:Carla
BuildRequires:	Mesa-libGL-devel
BuildRequires:	Qt5Core-devel
BuildRequires:	Qt5Gui-devel
BuildRequires:	QtCore-devel
BuildRequires:	QtGui-devel
BuildRequires:	alsa-lib-devel
BuildRequires:	fftw3-devel
BuildRequires:	fltk-devel
BuildRequires:	fluidsynth-devel >= 2.0.0
BuildRequires:	gtk+2-devel
BuildRequires:	gtk+3-devel
BuildRequires:	liblo-devel
BuildRequires:	libprojectM-devel
BuildRequires:	mxml-devel
BuildRequires:	pulseaudio-devel
BuildRequires:	python3
BuildRequires:	python3-PyQt5
BuildRequires:	python3-PyQt5-uic
BuildRequires:	python-PyQt5-devel-tools >= 5.8.2-2
BuildRequires:	python-PyQt5-uic
BuildRequires:	rpm-pythonprov
BuildRequires:	zlib-devel
Requires:	python3-PyQt5
Requires:	python3-numpy
Suggests:	python3-rdflib
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define	_noautoprovfiles	%{_libdir}/(lv2|vst|carla/jack/libjack.so)

%description
Carla is a fully-featured audio plugin host, with support for many
audio drivers and plugin formats.

%package devel
Summary:	Header files for %{name} library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki %{name}
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
Header files for %{name} library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki %{name}.

%prep
%setup -q -n %{name}-1.9.12 -a 1

rmdir source/native-plugins/external
mv Carla-Plugins-%{plugins_rev}* source/native-plugins/external

#%patch0 -p1
%patch1 -p1

%build
# to make sure all needed features are available
%{__make} -j1 features \
	EXTERNAL_PLUGINS=true \
	SKIP_STRIPPING=true \
	CC="%{__cc}" \
	CXX="%{__cxx}" \
	CFLAGS="%{rpmcflags}" \
	CXXFLAGS="%{rpmcxxflags}" \
	LDFLAGS="%{rpmldflags}" \
	PREFIX=%{_prefix} \
	PYUIC4=%{_bindir}/pyuic4-3 \
	PYUIC5=%{_bindir}/pyuic5-3 \
	PYUIC=%{_bindir}/pyuic5-3 \
	LIBDIR=%{_libdir}

%{__make} -j1 all \
	--trace \
	EXTERNAL_PLUGINS=true \
	SKIP_STRIPPING=true \
	CC="%{__cc}" \
	CXX="%{__cxx}" \
	CFLAGS="%{rpmcflags}" \
	CXXFLAGS="%{rpmcxxflags}" \
	LDFLAGS="%{rpmldflags}" \
	PREFIX=%{_prefix} \
	PYUIC4=%{_bindir}/pyuic4-3 \
	PYUIC5=%{_bindir}/pyuic5-3 \
	PYUIC=%{_bindir}/pyuic5-3 \
	LIBDIR=%{_libdir}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	PREFIX=%{_prefix} \
	LIBDIR=%{_libdir} \
	PYPKGDIR=%{py3_sitescriptdir} \
	DESTDIR=$RPM_BUILD_ROOT

%{__sed} -i -e '1s,^#!.*python3\?,#!%{__python3},' \
	$RPM_BUILD_ROOT/%{_datadir}/carla/resources/*-* \
	$RPM_BUILD_ROOT/%{_bindir}/*

%py3_comp $RPM_BUILD_ROOT%{_datadir}/carla

# so debuginfo is properly extracted
chmod a+x $RPM_BUILD_ROOT%{_libdir}/carla/{,*/}*.so

ln -s ../__pycache__ $RPM_BUILD_ROOT%{_datadir}/carla/resources/__pycache__

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc README.md
%attr(755,root,root) %{_bindir}/*
%dir %{_libdir}/carla
%dir %{_libdir}/carla/styles
%{_libdir}/carla/styles/carlastyle.json
%attr(755,root,root) %{_libdir}/carla/styles/carlastyle.so
%attr(755,root,root) %{_libdir}/carla/carla-*
%attr(755,root,root) %{_libdir}/carla/libcarla*.so
%dir %{_libdir}/carla/jack
%attr(755,root,root) %{_libdir}/carla/jack/libjack.so.0
%dir %{_libdir}/lv2/carla.lv2
%{_libdir}/lv2/carla.lv2/*.ttl
%attr(755,root,root) %{_libdir}/lv2/carla.lv2/*.so
%attr(755,root,root) %{_libdir}/lv2/carla.lv2/carla-bridge-lv2-*
%attr(755,root,root) %{_libdir}/lv2/carla.lv2/carla-bridge-native
%attr(755,root,root) %{_libdir}/lv2/carla.lv2/carla-discovery-native
%{_libdir}/lv2/carla.lv2/jack
%{_libdir}/lv2/carla.lv2/resources
%{_libdir}/lv2/carla.lv2/styles
%dir %{_libdir}/vst
%dir %{_libdir}/vst/carla.vst
%attr(755,root,root) %{_libdir}/vst/carla.vst/*.so
%attr(755,root,root) %{_libdir}/vst/carla.vst/carla-bridge-lv2-*
%attr(755,root,root) %{_libdir}/vst/carla.vst/carla-bridge-native
%attr(755,root,root) %{_libdir}/vst/carla.vst/carla-discovery-native
%{_libdir}/vst/carla.vst/jack
%{_libdir}/vst/carla.vst/resources
%{_libdir}/vst/carla.vst/styles
%{_desktopdir}/carla.desktop
%{_desktopdir}/carla-control.desktop
%dir %{_datadir}/carla
%dir %{_datadir}/carla/resources
%{_datadir}/carla/resources/widgets
%{_datadir}/carla/resources/zynaddsubfx
%{_datadir}/carla/resources/*.py
%{_datadir}/carla/resources/__pycache__
%attr(755,root,root) %{_datadir}/carla/carla-control
%attr(755,root,root) %{_datadir}/carla/carla-jack-multi
%attr(755,root,root) %{_datadir}/carla/carla-jack-single
%attr(755,root,root) %{_datadir}/carla/resources/bigmeter-ui
%attr(755,root,root) %{_datadir}/carla/resources/carla-plugin
%attr(755,root,root) %{_datadir}/carla/resources/carla-plugin-patchbay
%attr(755,root,root) %{_datadir}/carla/resources/midipattern-ui
%attr(755,root,root) %{_datadir}/carla/resources/notes-ui
%attr(755,root,root) %{_datadir}/carla/resources/zynaddsubfx-ui
%{_datadir}/carla/widgets
%{_datadir}/carla/*.py
%{_datadir}/carla/__pycache__
%{_datadir}/carla/carla
%{_datadir}/carla/carla-patchbay
%{_datadir}/carla/carla-rack
%{_iconsdir}/hicolor/*/apps/*
%{_datadir}/mime/packages/carla.xml

%files devel
%defattr(644,root,root,755)
%{_includedir}/carla
%{_pkgconfigdir}/carla-native-plugin.pc
%{_pkgconfigdir}/carla-standalone.pc
%{_pkgconfigdir}/carla-utils.pc
%changelog
* Wed Nov 21 2018 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/Carla.git;a=log;h=master

* Wed Nov 21 2018 Jacek Konieczny <j.konieczny@eggsoft.pl> e79bf51
- rel 3

* Wed Nov 21 2018 Jacek Konieczny <j.konieczny@eggsoft.pl> 15e5980
- BR: python3-PyQt5-uic

* Wed Nov 21 2018 Jacek Konieczny <j.konieczny@eggsoft.pl> 256c07c
- require main package in Carla-devel

* Mon Nov 19 2018 Jacek Konieczny <j.konieczny@eggsoft.pl> 5581c36
- up to 2.0-RC2, rebuild with fluidsynth 2

* Thu Sep 13 2018 Jacek Konieczny <j.konieczny@eggsoft.pl> 0ee9007
- Version: v1.9.9

* Thu Jul 05 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 029c785
- release 5 (by relup.sh)

* Thu Apr 26 2018 Jan Rękorajski <baggins@pld-linux.org> 631a933
- rebuild with ffmpeg 4.0
- rel 4

* Thu Mar 01 2018 Jacek Konieczny <j.konieczny@eggsoft.pl> a961335
- Patch added for proper mmap() error handling

* Thu Mar 01 2018 Jacek Konieczny <j.konieczny@eggsoft.pl> f200b7c
- Use '--trace' for make, as default build is too quiet

* Thu Mar 01 2018 Jacek Konieczny <j.konieczny@eggsoft.pl> 2c3709f
- set +x bit on binaries to extract debuginfo

* Thu Mar 01 2018 Jacek Konieczny <j.konieczny@eggsoft.pl> 7b5b5af
- do not strip binaries

* Thu Mar 01 2018 Jacek Konieczny <j.konieczny@eggsoft.pl> 32c96d7
- Release: .3

* Thu Mar 01 2018 Jacek Konieczny <j.konieczny@eggsoft.pl> 7a724d2
- a bugfix from upstream

* Thu Mar 01 2018 Jacek Konieczny <j.konieczny@eggsoft.pl> 5392685
- Require Python 2 PyQt tools

* Sun Feb 04 2018 Jacek Konieczny <jajcus@jajcus.net> 75127a2
- Include LinuxSampler support

* Sat Feb 03 2018 Jacek Konieczny <jajcus@jajcus.net> 6b73e29
- BR: latest python-PyQt5-devel-tools

* Sat Feb 03 2018 Jacek Konieczny <jajcus@jajcus.net> bd1288e
- add /usr/share/soundfonts to default search paths

* Sat Feb 03 2018 Jacek Konieczny <jajcus@jajcus.net> fd27cd9
- BR: python3-PyQt5

* Sat Feb 03 2018 Jacek Konieczny <jajcus@jajcus.net> 399e228
- Version: 2.0-beta6

* Sat Nov 19 2016 Jacek Konieczny <jajcus@jajcus.net> 1337563
- Make default qt5 optional

